import { Resolvable } from 'villa';
import { Context } from './command';
export declare type PrintableOutputLevel = 'log' | 'info' | 'warn' | 'error';
export interface Printable {
    print(stdout: NodeJS.WritableStream, stderr: NodeJS.WritableStream): Promise<void> | void;
}
export declare function isPrintable(object: any): object is Printable;
export interface StringCastable<T> extends Clime.Constructor<T> {
    cast(source: string, context: Context): Resolvable<T>;
}
export declare function isStringCastable<T>(constructor: Clime.Constructor<T>): constructor is StringCastable<T>;
