"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const FS = require('fs');
const PathModule = require('path');
const villa_1 = require('villa');
const core_1 = require('../core');
class File {
    constructor(source, cwd) {
        this.source = source;
        this.cwd = cwd;
        this.baseName = PathModule.basename(source);
        this.fullName = PathModule.resolve(cwd, source);
    }
    require() {
        try {
            return require(this.fullName);
        }
        catch (error) {
            throw new core_1.ExpectedError(`Error parsing requiring file "${this.source}"`);
        }
    }
    assert(exists = true) {
        return __awaiter(this, void 0, void 0, function* () {
            let stats;
            try {
                stats = yield villa_1.call(FS.stat, this.fullName);
            }
            catch (error) { }
            if (exists) {
                if (!stats) {
                    throw new core_1.ExpectedError(`File "${this.source}" does not exist`);
                }
                if (!stats.isFile()) {
                    throw new core_1.ExpectedError(`Path "${this.source}" is expected to be a file`);
                }
            }
            else if (stats) {
                throw new core_1.ExpectedError(`Path "${this.source}" already exists`);
            }
        });
    }
    static cast(name, context) {
        return new this(name, context.cwd);
    }
}
exports.File = File;
//# sourceMappingURL=fs.js.map