"use strict";
const _1 = require('../core/');
class RangeValidator {
    constructor(
        /** value >= from. */
        from, 
        /** value < to. */
        to) {
        this.from = from;
        this.to = to;
    }
    validate(value, name) {
        if (value < this.from || value >= this.to) {
            throw new _1.ExpectedError(`Value of \`${name}\` is not within the range of [${this.from}, ${this.to})`);
        }
    }
}
exports.RangeValidator = RangeValidator;
function range(from, to) {
    return new RangeValidator(from, to);
}
exports.range = range;
class IntegerValidator {
    validate(value, name) {
        if (value % 1 !== 0) {
            throw new _1.ExpectedError(`Value of \`${name}\` is not an integer`);
        }
    }
}
exports.IntegerValidator = IntegerValidator;
exports.integer = new IntegerValidator();
//# sourceMappingURL=validation.js.map